Bug 1384460 - segment fault while join thread reaper_thr in fini()
Summary: segment fault while join thread reaper_thr in fini()
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Gluster Storage
Classification: Red Hat
Component: upcall
Version: rhgs-3.2
Hardware: x86_64
OS: Linux
unspecified
high
Target Milestone: ---
: RHGS 3.2.0
Assignee: Soumya Koduri
QA Contact: surabhi
URL:
Whiteboard:
Depends On: 1369524 1371196
Blocks: 1351528
TreeView+ depends on / blocked
 
Reported: 2016-10-13 10:20 UTC by Shashank Raj
Modified: 2017-03-23 06:09 UTC (History)
9 users (show)

Fixed In Version: glusterfs-3.8.4-1
Doc Type: If docs needed, set a value
Doc Text:
Clone Of: 1371196
Environment:
Last Closed: 2017-03-23 06:09:54 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2017:0486 normal SHIPPED_LIVE Moderate: Red Hat Gluster Storage 3.2.0 security, bug fix, and enhancement update 2017-03-23 09:18:45 UTC

Description Shashank Raj 2016-10-13 10:20:36 UTC
+++ This bug was initially created as a clone of Bug #1371196 +++

+++ This bug was initially created as a clone of Bug #1369524 +++

Description of problem:

reaper_thr thread may not be started according to option 'cache-invalidation', if it's not started, the following code in fini() will cause segment fault:

        priv->fini = 1; 

        pthread_join (priv->reaper_thr, NULL);

--- Additional comment from Worker Ant on 2016-08-23 18:30:26 CEST ---

REVIEW: http://review.gluster.org/15298 (features/upcall: segment fault while join thread reaper_thr in fini()) posted (#1) for review on master by Anonymous Coward

--- Additional comment from Worker Ant on 2016-08-25 22:50:09 CEST ---

REVIEW: http://review.gluster.org/15298 (features/upcall: segment fault while join thread reaper_thr in fini()) posted (#2) for review on master by Niels de Vos (ndevos@redhat.com)

--- Additional comment from Worker Ant on 2016-08-29 14:13:54 CEST ---

COMMIT: http://review.gluster.org/15298 committed in master by Jeff Darcy (jdarcy@redhat.com) 
------
commit 7f0042dce94edb58c92662d9e4f852ba006d12dc
Author: Ryan Ding <ryan.ding@open-fs.com>
Date:   Wed Aug 24 00:24:30 2016 +0800

    features/upcall: segment fault while join thread reaper_thr in fini()
    
    reaper_thr thread may not be started according to option
    'cache-invalidation', if it's not started, join it in fini will cause a
    segment fault.
    
    Change-Id: I1c145a5feb137767880a08e79f810537283fb6b9
    BUG: 1369524
    Signed-off-by: Ryan Ding <ryan.ding@open-fs.com>
    [ndevos: check .reaper_init_done and make it a boolean]
    Reviewed-on: http://review.gluster.org/15298
    Smoke: Gluster Build System <jenkins@build.gluster.org>
    Reviewed-by: soumya k <skoduri@redhat.com>
    Reviewed-by: Niels de Vos <ndevos@redhat.com>
    NetBSD-regression: NetBSD Build System <jenkins@build.gluster.org>
    CentOS-regression: Gluster Build System <jenkins@build.gluster.org>

--- Additional comment from Worker Ant on 2016-08-29 10:31:02 EDT ---

REVIEW: http://review.gluster.org/15337 (features/upcall: segment fault while join thread reaper_thr in fini()) posted (#1) for review on release-3.7 by Niels de Vos (ndevos@redhat.com)

--- Additional comment from Worker Ant on 2016-09-05 05:07:25 EDT ---

COMMIT: http://review.gluster.org/15337 committed in release-3.7 by Niels de Vos (ndevos@redhat.com) 
------
commit 337fb7f4e14240fa6553e34094bc07f24fe897b6
Author: Niels de Vos <ndevos@redhat.com>
Date:   Mon Aug 29 16:30:16 2016 +0200

    features/upcall: segment fault while join thread reaper_thr in fini()
    
    reaper_thr thread may not be started according to option
    'cache-invalidation', if it's not started, join it in fini will cause a
    segment fault.
    
    Cherry picked from commit 7f0042dce94edb58c92662d9e4f852ba006d12dc:
    > Change-Id: I1c145a5feb137767880a08e79f810537283fb6b9
    > BUG: 1369524
    > Signed-off-by: Ryan Ding <ryan.ding@open-fs.com>
    > [ndevos: check .reaper_init_done and make it a boolean]
    > Reviewed-on: http://review.gluster.org/15298
    > Smoke: Gluster Build System <jenkins@build.gluster.org>
    > Reviewed-by: soumya k <skoduri@redhat.com>
    > Reviewed-by: Niels de Vos <ndevos@redhat.com>
    > NetBSD-regression: NetBSD Build System <jenkins@build.gluster.org>
    > CentOS-regression: Gluster Build System <jenkins@build.gluster.org>
    
    Change-Id: I1c145a5feb137767880a08e79f810537283fb6b9
    BUG: 1371196
    Signed-off-by: Niels de Vos <ndevos@redhat.com>
    Reviewed-on: http://review.gluster.org/15337
    Smoke: Gluster Build System <jenkins@build.gluster.org>
    NetBSD-regression: NetBSD Build System <jenkins@build.gluster.org>
    CentOS-regression: Gluster Build System <jenkins@build.gluster.org>
    Reviewed-by: Ryan Ding <ryan.ding@open-fs.com>
    Reviewed-by: soumya k <skoduri@redhat.com>

Comment 2 Niels de Vos 2016-10-13 11:57:47 UTC
POST? Please add a link to the patch or commit-id.

Comment 3 Soumya Koduri 2016-10-13 12:00:29 UTC
Patch merged in upstream - http://review.gluster.org/15298 

Hence in POST state.

Comment 9 surabhi 2016-11-23 12:32:45 UTC
As discussed with Soumya, executed following:

1. On a 4 node ganesha cluster, mounted a volume using nfsv4, started I/O's (fileop script from fs-sanity) 
2. Execute cache-invalidate option on and off multiple times (20) , did'nt see any crash or segfault .
all services are up and running.

Marking the BZ verified.

Comment 11 errata-xmlrpc 2017-03-23 06:09:54 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://rhn.redhat.com/errata/RHSA-2017-0486.html


Note You need to log in before you can comment on or make changes to this bug.